/*******************************************************************
 * Time to limber up my C skillz a bit.  
 * Time to prove that C is God's chosen language!  
 * Time to prove that C is the best language for everything!
 * ...especially string processing.
 * Time to kludge something together that doesn't die too fast.
 * Time to put everything in one big module, with lots of globals, 
 * and generally regress back to spaghetti code just for a day or two.
 *
 * Normally I'd win ...however, I started late.... so we'll see.
 *
 *******************************************************************/
#define ROBOT_MAIN
#include "robot.h"
#include <stdarg.h>

char buf[2048];
void display_board()
{
	package_t *pkg=NULL;
	robot_t *robot=NULL;
	char *p, c;
	int x,y, start_y, start_x;
	usleep(30000);
	printf("[H");
	start_y=1; start_x=1;
	if (world_y>28) start_y=me.y-14; if (start_y<1) start_y=1;
	if (world_x>76) start_x=me.x-33; if (start_x<1) start_x=1;
	if (world_y-start_y<27) start_y=world_y-27;
	if (world_x-start_x<75) start_x=world_x-75;
	if (start_y<1) start_y=1;
	if (start_x<1) start_x=1;
	for (y=start_y; y<=world_y&&y<start_y+27; y++)
	{
		p=buf;
		for (x=start_x; x<=world_x&&x<start_x+75; x++)
		{
			if(x==me.x && y==me.y)
				*p++='X';
			else
			{
				for (robot = robots; robot; robot=robot->next)
				{
					if (robot->x==x && robot->y==y)
					{
						*p++='Y';
						break;
					}
				} 
				if (!robot) switch(world[x][y].type)
				{
					case WALL:  *p++='#'; break;
					case WATER: *p++='~'; break;
					case BASE:  *p++='@'; break;
					case PLAIN: 
						c='.';
						for (pkg=world[x][y].packages; pkg; pkg=pkg->wnext)
						{
							if (c=='.') c='?';
							if (pkg->dest_x>0) c='o';
						}
						if (main_goal && main_goal->x==x && main_goal->y==y)
							c='+';

						*p++=c;
						break;
				}
			}
		}
		*p++='\n'; 
		*p++='\0';
		printf("%s", buf);
	}
	printf("Score: % 9d[K\n", me.score);
	printf("Load:  % 4d/% 4d.[K\n", me.load, me.max_load);
	printf("Anger: % 9d.[K\n", me.angry);
	printf("Money: % 9d.[K\n", me.money);

	for (x=0,pkg=me.packages ; pkg ; pkg=pkg->mnext) x++;
	if (x)
		printf("You have %d %s.[K\n[K\n", x, x>1?"packages" : "package");
	else
		printf("No packages.[K\n[K\n");
//	memwrap(printf);
}

/*******************************************************************
     int nextline (sock, buffer, p)

  Description:  Get next line from buffer or socket
  Arguments:    
     int sock .......socket to read from
     char *buffer ...
     char **p .......current pos - at or before \n of current line
  Return:       zero on success
 *******************************************************************/
int nextline(int sock, char *buffer, char **p)
{
	char *q;

	if (q=strchr(*p, '\n'))
	{
		q++;
		if (*q=='\0')
		{
			q=buffer;
			buffer[0]='\0';
		}
		else
		{
			memmove(buffer, q, strlen(q)+1);
			if (strchr(buffer, '\n'))
			{
				*p=buffer;
				return 0;
			}
			q=strchr(buffer, '\0');
		}
	} else
	{
		q=buffer;
		buffer[0]='\0';
	}

	while (!strchr(q, '\n'))
	{
		int rc;
		int bufleft = BUFSIZE-1-(q-buffer);

		if (0>=(rc=ss_read(sock, q, bufleft>2048 ? 2048 : bufleft)))
			return -1;
		if (!strchr(q, '\n'))
			q+=rc;
	}
	*p=buffer;
	return 0;
}

void remove_from_world(int x, int y, int n)
{
	package_t *p;
	while (world[x][y].packages && world[x][y].packages->n==n)
		world[x][y].packages = world[x][y].packages->wnext;
	for (p=world[x][y].packages; p; p=p->wnext)
		if (p->wnext && ((package_t *)p->wnext)->n==n)
			p->wnext = ((package_t *)p->wnext)->wnext;
}

void remove_package(int n)
{
	package_t *p, *pkg=NULL;
	
	if (packages && packages->n==n)
	{
		pkg=packages;
		packages = packages->next;
	} 
	else for (p=packages; p; p=p->next)
	{
		if (p->next && ((package_t *)p->next)->n==n)
		{
			pkg = p->next;
			p->next = ((package_t *)p->next)->next;
			break;
		}
	}

	if (!pkg)  //???
		return;

#if 1 //(there was a bug that this avoided - it's not strictly necessary now)
	//remove from world list
	if (pkg->x>0 && pkg->y>0)
		remove_from_world(pkg->x, pkg->y, n);

	//remove from my list 
	while (me.packages && me.packages->n==n)
		me.packages = me.packages->mnext;
	for (p=me.packages; p; p=p->mnext)
		if (p->mnext && ((package_t *)p->mnext)->n==n)
			p->mnext = ((package_t *)p->mnext)->mnext;
#endif

	free_path(&pkg->path);
	free(pkg);
}

package_t *find_package(int n)
{
	package_t *p;
	for (p=packages; p; p=p->next)
		if (p->n==n)
				break;
	return p;
}

int update_packages(char *buf)
{
	char *p;
	int n, x, y, w;
	package_t *package;


#if 1  //  ... I dunno.. maybe if I do this
	for (package=packages; package; package=package?package->next:NULL)
	{
		while (package && package->owner==NULL && package->x==me.x && package->y==me.y)
		{
			remove_package(package->n);
			package=packages;
		}
	}
#endif

	world[me.x][me.y].packages = NULL; // what the hell...

	p=buf;
	while (p=parseints(p, 4, &n, &x, &y, &w))
	{
		//printf("found a package %d for (%d,%d) weight %d.\n", n, x, y, w);
		if ((package=find_package(n)))
		{
			free_path(&(package->path));
		}
		else
		{
			package = malloc(sizeof(package_t));
			memset(package, 0x00, sizeof(package_t));
			package->next = packages;
			packages = package;
			package->path=NULL;
			package->mnext  = NULL;
			package->owner  = NULL;
		}

		//add to world
		package->wnext  = world[me.x][me.y].packages;
		world[me.x][me.y].packages = package;

		if (package->path==NULL && world[me.x][me.y].type!=BASE)
			package->path = find_path(me.x, me.y, 1);
		package->x      = me.x;
		package->y      = me.y;
		package->n      = n;
		package->dest_x = x;
		package->dest_y = y;
		package->weight = w;
	}
	return 0;
}

void pickup(package_t *pkg)
{
	package_t *p;
	
	//add to the end of my pkg list
	//xxx might want to figure out if there's a better place to insert it.
	if  (!me.packages)  me.packages = pkg;
	else  { for (p=me.packages; p->mnext; p=p->mnext); p->mnext = pkg; }

	pkg->mnext = NULL;
	pkg->owner = &me;
	me.load   += pkg->weight;

	//remove from world list
	while (world[pkg->x][pkg->y].packages==pkg)
		world[pkg->x][pkg->y].packages = world[pkg->x][pkg->y].packages->wnext;
	for (p=world[pkg->x][pkg->y].packages; p; p=p->wnext)
		if (p->wnext && p->wnext==pkg)
			p->wnext = pkg->wnext;
}

/*******************************************************************
     int update_status (buf)

  Description:  update game status based on server response
  Arguments:    char *buf ...server response line
  Return:       zero on success
 *******************************************************************/
#define UPDATE_ERR(x) { errmsg=x; goto UPDATE_ERROR; }
int update_status(char *buf)
{
	robot_t    *robot, *nrobot;
	package_t  *package;
	char       *errmsg;
	char       *p;
	int         n=-1;  /* I presume that -1 is invalid as identifier..? */
	int         pkgno=-1;
	int flag=0;

	for (p=buf; *p&&isspace(*p); p++);
	for (robot=robots; robot; robot=robot->next)
		robot->alive=0;

	turn++;
	n_robots = 0;
	while (*p=='#')
	{
		/* get n */
		p++;
		for (; *p&&*p!='\n'&&isspace(*p); p++);
		if (NULL==(p=parseints(p, 1, &n))) UPDATE_ERR("I'm confused.");

		/* find robot n, or add a new one */
		if (n==me.n) 
		{
			flag=1;
			robot=&me;  /* I'm a special case */
		}
		else
		{
			n_robots++;
			for (robot=robots; robot; robot=robot->next)
				if (robot->n==n)
					break;
			if (!robot)
			{
				robot = malloc(sizeof(robot_t));
				memset(robot, 0x00, sizeof(robot_t));
				robot->n=n;
				robot->angry=1;
				robot->next = robots;
				robots = robot;
			}
		}
		robot->alive=1;

		/* x, y, moves, pickups, drops */
		for (; *p&&*p!='\n'&&isspace(*p); p++);
		if (robot==&me && (*p=='\n' || *p=='#'))
		{
			if (lastmove!='D')
				me.angry = (me.angry+2)*3;
		}
		while (*p && *p!='\n' && *p!='#')
		{
			switch(*p)
			{
			case 'X':
				if (robot->x) world[robot->x][robot->y].robot=NULL;
				p++;
				if (NULL==(p = parseints(p, 1, &(robot->x)))) UPDATE_ERR("Bad X");
				break;
			case 'Y':
				p++;
				if (NULL==(p = parseints(p, 1, &(robot->y)))) UPDATE_ERR("Bad Y");
				world[robot->x][robot->y].robot=robot;
				if (robot==&me) printf("I start at (%d,%d)\n", robot->x, robot->y);
				break;
			case 'N': case 'S': case 'E': case 'W':
				if (robot==&me && lastmove!='D' && lastmove!=*p)
					me.angry = (me.angry+2)*3;

				world[robot->x][robot->y].robot=NULL;
				robot->x+=DX(*p); robot->y+=DY(*p);
				if (robot->x<=0 || robot->y<=0 || robot->x>world_x || robot->y>world_y)
				{
					fprintf(stderr, "robot %d moved %c to (%d,%d)\n", 
					                 n, *p, robot->x, robot->y);
					UPDATE_ERR("Bad robot move.");
				}
				world[robot->x][robot->y].robot=robot;
				p++;
				break;
			case 'P':
				p++;
				if (NULL==(p = parseints(p, 1, &pkgno))) UPDATE_ERR("Bad pickup");
				if (package = find_package(pkgno))
				{
					package->owner = robot;
					if (robot==&me)
					{
						free_goal(&main_goal);
						pickup(package);
						//printf("picked up a package!\n");
					}
					else
					{
						if (world[robot->x][robot->y].type==BASE
								&& !world[robot->x][robot->y].packages)
						{
							base_t *base;
							for (base = bases; base; base = base->next)
								if (base->x==robot->x && base->y==robot->y)
								{
									// gotta visit that one someday
									base->visited = 0;
									break;
								}
						}
						remove_from_world(robot->x, robot->y, package->n);
						free_path(&package->path);
					}
				} else
				{
					//printf("Someone picked up an un-tracked package.\n");
					// add to list...?  no way - too complex to track moving pkgs.
					;
				}
				break;
			case 'D':
				if (robot==&me && lastmove!='D')
				{
					free_goal(&main_goal);
					me.angry = (me.angry+2)*3;
				}

				p++;
				if (NULL==(p = parseints(p, 1, &pkgno))) UPDATE_ERR("Bad drop");
				if (package = find_package(pkgno))
				{
					if (robot==&me)
					{
						free_goal(&main_goal);
						if (package->dest_x==me.x && me.y==package->dest_y)
							me.score+=package->weight;
						me.load-=package->weight;
					}
					package->owner = NULL;
					package->x = robot->x;
					package->y = robot->y;
					if (   package->x==package->dest_x
					    && package->y==package->dest_y)
					{
							package_t *p;
							while (me.packages && me.packages->n==pkgno)
								me.packages = me.packages->mnext;
							for (p=me.packages; p; p=p->mnext)
								if (p->mnext && ((package_t *)p->mnext)->n==pkgno)
									p->mnext = ((package_t *)p->mnext)->mnext;
						remove_package(pkgno);  //ferget it.
					} else
					{
						/* not at dest */
						free_goal(&main_goal);
						free_path(&package->path);
						if (world[robot->x][robot->y].type!=BASE)
						{
							package->path = find_path(robot->x, robot->y, 1);
						}
						if (1||robot==&me) 
						{
							package_t *p;
							while (me.packages && me.packages->n==pkgno)
								me.packages = me.packages->mnext;
							for (p=me.packages; p; p=p->mnext)
								if (p->mnext && ((package_t *)p->mnext)->n==pkgno)
									p->mnext = ((package_t *)p->mnext)->mnext;
						}

						// add to world
						package->wnext  = world[robot->x][robot->y].packages;
						world[robot->x][robot->y].packages = package;
					} 
				} else
				{
					//printf("someone dropped a package I don't know about.\n");
					package = malloc(sizeof(package_t));
					memset(package, 0x00, sizeof(package_t));
					package->next = packages;
					packages = package;

					//add to world
					package->wnext  = world[robot->x][robot->y].packages;
					world[robot->x][robot->y].packages = package;

					free_path(&package->path);
					if (world[robot->x][robot->y].type!=BASE)
						package->path = find_path(robot->x, robot->y, 1);
					package->owner  = NULL;
					package->x      = robot->x;
					package->y      = robot->y;
					package->n      = pkgno;
					package->dest_x = -1;
					package->dest_y = -1;
					package->weight = 0;
					package->mnext  = NULL;
				}
				break;
			case '\n': 
				break;
			default:
				UPDATE_ERR("I'm horribly confused.");
			}
			for (; *p&&*p!='\n'&&isspace(*p); p++);
		}
		if (robot->x<=0 || robot->y<=0 || robot->x>world_x || robot->y>world_y)
		{
			fprintf(stderr, "robot %x is at (%d,%d)\n", n, robot->x, robot->y);
			UPDATE_ERR("Bad robot location.");
		}
	}

	/* eliminate the dead */
	while (robots && !robots->alive)
	{
		nrobot = robots->next;
		free(robots);
		robots=nrobot;
	}
	for (robot = robots; robot; robot=robot->next)
	{
		nrobot=robot->next;
		if (nrobot && !nrobot->alive)
		{
			robot->next = nrobot->next;
			free(nrobot);
		}
	}

	display_board();

	if (n==-1) 
	{
		printf("update got: %s", buffer);
	}
	if (!flag)
		printf("I'm lost.\n");
	return n==-1 ? n : 0;

	UPDATE_ERROR:
		fprintf(stderr, "error in update: %s\n", errmsg);
		fprintf(stderr, "server said: %s", buf);
		fprintf(stderr, "I got to: %s", p);
		fprintf(stderr, "n was %d.\n", n);
		return -2;
}

/*******************************************************************
     char *parseints (buf, n, ...)

  Description:  get values from some space-separated ints
  Arguments:    
     char *buf ......the input string
     int n ..........number of ints to grab
     ...(int*) ......then some places to put them
  Return:       pointer to next char in input string
 *******************************************************************/
char *parseints(char *buf, int n, ...)
{
	va_list ap;
	int i, v, *ip;
	int count=0;
	char c, *sp, *ep=NULL;

	va_start(ap, n);
	for ( sp=buf, i=0; i<n ; i++)
	{
		ip = va_arg(ap, int *);

		/* find start of int */
		for (; *sp && strchr(" ", *sp); sp++);
		if (!isdigit(*sp)) continue;

		count++;

		/* get value */
		for (ep=sp; !strchr(" \n", *ep); ep++);
		c=*ep; *ep='\0'; v=atoi(sp); *ep=c;

		/* assign */
		*ip = v;

		sp=ep;
	}
	va_end(ap);
	return count==n ? ep : NULL;
}

#define INIT_ERR(x) { errmsg=x; state = ERROR; goto INIT_ERROR; }
int init(const char *host, int port)
{
	base_t *base;
	char *errmsg = "error in init\n";
	char *p;
	int i, x, y;
	enum { PLAYER, BOARDSIZE, BOARD, CONFIG, ROBOTS, DONE, ERROR } state;

	robots   = NULL;
	packages = NULL;
	bases    = NULL;

	if (ss_init())
	{
		fprintf(stderr, "ss_init failed.\n");
		exit(1);
	}

	if (0>=(sock=ss_open(host, port)))
	{
		fprintf(stderr, "no connection\n");
		return -1;
	}
	printf("connected...loading board\n");
	szsend(sock, "Player\n");

	state = PLAYER;
	buffer[0]='\0';
	p=buffer;
	for (state=PLAYER; state!=DONE; )
	{
		if (0>nextline(sock, buffer, &p))
		{
			fprintf(stderr, "broken read\n");
			return -1;
		}
		switch(state)
		{
		case PLAYER:
			state = BOARDSIZE;  //oops.
		case BOARDSIZE:
			for (x=0; x<=world_x+1; x++) for(y=0; y<=world_y+1; y++)
				memset(&world[x][y], 0x00, sizeof(world_t));
			if (!parseints(p, 2, &world_x, &world_y) )
				INIT_ERR("Error parsing board size.");

			if ( world_x > MAXWORLD-2 || world_y > MAXWORLD-2 )
				INIT_ERR("error: I'm too lazy to use a dynamically-allocated board.");
			if ( world_x < 1          || world_y < 1 )
				INIT_ERR("I quit.  It's a small world, after all.");

			for (i=0; i<=world_x; i++) 
				{world[i][0].type=WALL; world[i][0].passable=0; }
			for (i=0; i<=world_y; i++) 
				{world[0][i].type=WALL; world[0][i].passable=0; }
			for (i=0; i<=world_x; i++) 
				{world[i][world_y+1].type=WALL; world[i][world_y+1].passable=0;}
			for (i=0; i<=world_x; i++) 
				{world[world_x+1][i].type=WALL; world[world_x+1][i].passable=0;}
			state = BOARD;
			break;

		case BOARD:
			for (y=1; y<=world_y; y++)
			{
				for (x=1; x<=world_x; x++)
				{
					if (*p=='\n' || !*p) INIT_ERR("Missing board data");
					switch(*p)
					{
					case '.': world[x][y].type=PLAIN; world[x][y].passable=1; break;
					case '#': world[x][y].type=WALL;  world[x][y].passable=0; break;
					case '~': world[x][y].type=WATER; world[x][y].passable=0; break;
					case '@': world[x][y].type=BASE;  world[x][y].passable=1;
						base       = malloc(sizeof(base_t));
						base->visited=0;
						base->next = bases;
						bases      = base;
						base->x    = x;
						base->y    = y;
						break;
					case ' ':
					default: 
							  printf("%d,%d: %c\n", x, y, *p);
							  INIT_ERR("Invalid board data?");
					}
					p++;
				}
				if (0>nextline(sock, buffer, &p))
					INIT_ERR("broken read");
			}
			state = CONFIG;
			// trust the server...the server is good
			
		case CONFIG:
			if (!parseints(p, 3, &me.n, &me.max_load, &me.money) )
				INIT_ERR("Error parsing config.");
			state = ROBOTS;
			break;

		case ROBOTS:
			lastmove='D';
			if (update_status(p))
				INIT_ERR("Couldn't understand game state.");
			state = DONE;

		case DONE: 
			if (0>nextline(sock, buffer, &p)) INIT_ERR("broken read");
			if (update_packages(buffer))      INIT_ERR("bad packages");
			break;

		default:
		case ERROR: INIT_ERROR:
			fprintf(stderr, "%s: %s\n", me.name, errmsg);
			shutdown(sock,2);
			close(sock);
			return -1;

		}
	}
	return 0;
}

int main(int argc, char *argv[])
{
	char *p;

	printf("[2J[H");
	memset(&me, 0x00, sizeof(me));
	memset(&world, 0x00, sizeof(world));
	main_goal=NULL;
	me.name = ((p=strrchr(argv[0],'/')) ? p+1 : argv[0]);
	me.angry=1; /* Grrrr! */
	if (argc!=3)
	{
		fprintf(stderr, "%s host port\n", me.name);
		exit(1);
	}
	if (init(argv[1], atoi(argv[2])))
	{
		exit(2);
	}
	
	run();

	/* will I bother to free the mallocs? */
	exit(0);
}
