/* Oh, never mind - better servers are available. */

#include "ss.h"
#include <signal.h>

int flag;
int package_waiting=1;

char world[1024][1024];
int x=1, y=1;
int world_x=0, world_y=0;

void reset(int sig)
{
	sig=0;
	flag=1;
	signal(SIGPIPE, reset);
	x=1, y=1;
}

//pretty lame.  just to test moving around.
int echo_move(int s, char *move)
{
	char buf[1024];
	char *p;
	if      (strchr(move, 'E')) { x++; szsend(s,"#3 E\n"); }
	else if (strchr(move, 'W')) { x--; szsend(s,"#3 W\n"); }
	else if (strchr(move, 'N')) { y++; szsend(s,"#3 N\n"); }
	else if (strchr(move, 'S')) { y--; szsend(s,"#3 S\n"); }
	else if ((p=strchr(move, 'P')) || (p=strchr(move, 'D')))
	{
		if (world[x][y]=='~')
		{
			return -1;
		}
		else if (world[x][y]=='#')
		{
			return -1;
		}
		sprintf(buf,"#3 %s", p); 
		szsend(s, buf); 
	}

	//packages
	if (world[y][x]=='@')
	{
		if (package_waiting)
			szsend(s,"1 3 5 9\n");
		else
			szsend(s,"\n");  
		package_waiting=!package_waiting;
	} else
		szsend(s,"\n");  
	return 0;
}

int init_world(char *wname)
{
	FILE *f;
	char *p;

	if (!(f=fopen(wname, "r")))
		return -1;
		
	while (fgets(world[world_y+1], 1024, f))
	{
		if (p=strchr(world[++world_y], '\n')) *p='\0';
		printf("%s\n", world[world_y]);
	}
	fclose(f);

	world_x=strlen(world[1]);

	return ((world_x==world_y && world_x==strlen(world[world_y-1])) && world_x>0) ? 0 : -1;
}

int main(int argc, char *argv[])
{
	int i; 
	int l=0,s=0; //sockets
	int money=1000;
	char buf[1024];
	signal(SIGPIPE, reset);
	if (init_world(argc>1?argv[1]:"world.w"))
	{
		fprintf(stderr, "no world.\n");
		exit(1);
	}

	ss_init();
	l=ss_listen(8088);

	if (0>=l) {fprintf(stderr, "no socket\n"); exit(1);}
	for (;;)
	{
		s=ss_accept(l);
		money=1000;
		package_waiting=1;
		x=y=1;
		szsend(s,"Player\n");
		sprintf(buf, "%d %d\n", world_x, world_y);
		szsend(s,buf);
		for (i=1; i<=world_y; i++)
		{
			sprintf(buf, "%s\n", world[i]);
			szsend(s, buf);
		}
		szsend(s,"3 250 1000\n");
		sprintf(buf, "#1 X 1 Y 9 #2 X 5 Y 5 #3 X %d Y %d\n", x, y);
		szsend(s, buf);
		szsend(s, "\n");


		for(;money;)
		{
			if (0>=ss_read(s, buf, 1000))
				break;
			if (echo_move(s, buf))
				break;
			money--;
		}
		sleep(1);
		shutdown(s, 2);
		close(s);
	}
	shutdown(l, 2);
	close(l);
	exit(0);
}
