#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <errno.h>
#include <string.h>

#ifdef __WINDOWS__
#   include <time.h>
#   include <windows.h>  
#   include <winsock.h>             /*  May cause trouble on VC 1.x      */
#   include <direct.h>   
#   include <process.h>   
#else
#   include <unistd.h>
#   include <sys/socket.h>
#   include <netdb.h>
#   include <netinet/in.h>
#   include <arpa/inet.h>
#endif

#define BUFSIZE 16384

int ss_init(void);
int ss_open(const char *host, unsigned int port);
int ss_listen(unsigned int port);
int ss_accept(int s);
int ss_read(int, char *, size_t);
int szsend(int s, const char *msg);

