#ifndef MEMWRAP_H
#define MEMWRAP_H

////////////////////////////////////MALLOC DEBUG
// wrap malloc/free/etc and keep track of what's allocated.
	int RouterMemoryConstruct (void);
	int RouterMemoryDestruct  (void);
	char *RouterStrdup        (const char *s, char *file, int line);
	void *RouterCalloc        (size_t n, size_t size, char *file, int line);
	void *RouterMalloc        (size_t size, char *file, int line);
	void RouterFree           (void *p, char *file, int line);
	void *RouterRealloc       (void *p, size_t size, char *file, int line);
#	ifndef ROUTER_MEMORY
#		define strdup(x)      RouterStrdup (x,    __FILE__, __LINE__)
#		define malloc(x)      RouterMalloc (x,    __FILE__, __LINE__)
#		define calloc(x, y)   RouterCalloc (x, y, __FILE__, __LINE__)
#		define free(x)        RouterFree   (x,    __FILE__, __LINE__)
#		define realloc(x, y)  RouterRealloc(x, y, __FILE__, __LINE__)
#	endif
#endif


